function [residual, g1, g2] = sw4_static(y, x, params)
%
% Status : Computes static model for Dynare
%
% Warning : this file is generated automatically by Dynare
%           from model file (.mod)

residual = zeros( 35, 1);

%
% Model equations
%

T21 = 1/(params(5)/(1-params(5)));
T37 = 1/(1+params(28)*params(26));
T43 = 1/(params(26)^2*params(7));
T60 = (1-params(8))/(params(29)+1-params(8));
T66 = params(10)/params(26);
T80 = (1-T66)/((1+T66)*params(9));
T191 = 1/(1+params(28)*params(26)*params(14));
T205 = (1-params(15))*(1-params(28)*params(26)*params(15))/params(15)/(1+(params(11)-1)*params(2));
T211 = params(28)*params(26)/(1+params(28)*params(26));
T238 = (1-params(13))*(1-params(28)*params(26)*params(13))/((1+params(28)*params(26))*params(13))*1/(1+(params(17)-1)*params(1));
T334 = 1-(T66/(1+T66)+1/(1+T66));
T336 = 1/(1-T66)-T66/(1-T66);
lhs =y(23);
rhs =params(4)*y(2)+(1-params(4))*y(9);
residual(1)= lhs-rhs;
lhs =y(1);
rhs =y(2)*T21;
residual(2)= lhs-rhs;
lhs =y(2);
rhs =y(9)+y(8)-y(3);
residual(3)= lhs-rhs;
lhs =y(3);
rhs =y(1)+y(26);
residual(4)= lhs-rhs;
lhs =y(6);
rhs =T37*(y(6)+y(6)*params(28)*params(26)+T43*y(4))+y(25);
residual(5)= lhs-rhs;
lhs =y(4);
rhs =(-y(10))+y(2)*params(29)/(params(29)+1-params(8))+y(4)*T60;
residual(6)= lhs-rhs;
lhs =y(5);
rhs =y(5)*T66/(1+T66)+y(5)*1/(1+T66)-y(10)*T80;
residual(7)= lhs-rhs;
lhs =y(7);
rhs =y(5)*params(36)+y(6)*params(35)+y(24)+y(1)*params(37);
residual(8)= lhs-rhs;
lhs =y(7);
rhs =params(11)*(y(23)+params(4)*y(3)+(1-params(4))*y(8));
residual(9)= lhs-rhs;
lhs =y(9);
rhs =y(8)*params(16)+y(5)*1/(1-T66)-y(5)*T66/(1-T66);
residual(10)= lhs-rhs;
lhs =y(26);
rhs =y(26)*(1-params(31))+y(6)*params(31)+y(25)*params(26)^2*params(7)*params(31);
residual(11)= lhs-rhs;
lhs =y(11);
rhs =params(4)*y(13)+(1-params(4))*y(21)-y(23);
residual(12)= lhs-rhs;
lhs =y(12);
rhs =T21*y(13);
residual(13)= lhs-rhs;
lhs =y(13);
rhs =y(21)+y(19)-y(14);
residual(14)= lhs-rhs;
lhs =y(14);
rhs =y(12)+y(27);
residual(15)= lhs-rhs;
lhs =y(27);
rhs =(1-params(31))*y(27)+params(31)*y(17)+y(25)*params(7)*params(26)^2*params(31);
residual(16)= lhs-rhs;
lhs =y(17);
rhs =y(25)+T37*(y(17)+params(28)*params(26)*y(17)+T43*y(15));
residual(17)= lhs-rhs;
lhs =y(15);
rhs =(-y(22))+y(20)+params(29)/(params(29)+1-params(8))*y(13)+T60*y(15);
residual(18)= lhs-rhs;
lhs =y(16);
rhs =T66/(1+T66)*y(16)+1/(1+T66)*y(16)-T80*(y(22)-y(20));
residual(19)= lhs-rhs;
lhs =y(18);
rhs =y(24)+params(36)*y(16)+params(35)*y(17)+params(37)*y(12);
residual(20)= lhs-rhs;
lhs =y(18);
rhs =params(11)*(y(23)+params(4)*y(14)+(1-params(4))*y(19));
residual(21)= lhs-rhs;
lhs =y(20);
rhs =T191*(params(28)*params(26)*y(20)+y(20)*params(14)+y(11)*T205);
residual(22)= lhs-rhs;
lhs =y(21);
rhs =T37*y(21)+y(21)*T211+y(20)*params(12)/(1+params(28)*params(26))-y(20)*(1+params(28)*params(26)*params(12))/(1+params(28)*params(26))+y(20)*T211+T238*(params(16)*y(19)+1/(1-T66)*y(16)-T66/(1-T66)*y(16)-y(21));
residual(23)= lhs-rhs;
lhs =y(22);
rhs =y(20)*params(18)*(1-params(21))+(1-params(21))*params(20)*(y(18)-y(7))+(y(18)-y(7))*params(19)+params(21)*y(28)+x(4);
residual(24)= lhs-rhs;
lhs =y(28);
rhs =y(22)-(y(18)-y(7))*params(19)/params(21);
residual(25)= lhs-rhs;
lhs =y(23);
rhs =y(23)*params(22)+x(1);
residual(26)= lhs-rhs;
lhs =y(24);
rhs =y(24)*params(23)+x(2)+x(1)*params(3);
residual(27)= lhs-rhs;
lhs =y(25);
rhs =y(25)*params(24)+x(3);
residual(28)= lhs-rhs;
lhs =y(29);
rhs =y(18)+log(params(40));
residual(29)= lhs-rhs;
lhs =y(30);
rhs =y(16)+log(params(41));
residual(30)= lhs-rhs;
lhs =y(31);
rhs =y(17)+log(params(42));
residual(31)= lhs-rhs;
lhs =y(32);
rhs =y(21)+log(params(43));
residual(32)= lhs-rhs;
lhs =y(33);
rhs =y(20)+log(params(44));
residual(33)= lhs-rhs;
lhs =y(34);
rhs =y(22)+log(params(45));
residual(34)= lhs-rhs;
lhs =y(35);
rhs =y(19)+log(params(46));
residual(35)= lhs-rhs;
if ~isreal(residual)
  residual = real(residual)+imag(residual).^2;
end
if nargout >= 2,
  g1 = zeros(35, 35);

%
% Jacobian matrix
%

  g1(1,2)=(-params(4));
  g1(1,9)=(-(1-params(4)));
  g1(1,23)=1;
  g1(2,1)=1;
  g1(2,2)=(-T21);
  g1(3,2)=1;
  g1(3,3)=1;
  g1(3,8)=(-1);
  g1(3,9)=(-1);
  g1(4,1)=(-1);
  g1(4,3)=1;
  g1(4,26)=(-1);
  g1(5,4)=(-(T37*T43));
  g1(5,6)=1-(1+params(28)*params(26))*T37;
  g1(5,25)=(-1);
  g1(6,2)=(-(params(29)/(params(29)+1-params(8))));
  g1(6,4)=1-T60;
  g1(6,10)=1;
  g1(7,5)=T334;
  g1(7,10)=T80;
  g1(8,1)=(-params(37));
  g1(8,5)=(-params(36));
  g1(8,6)=(-params(35));
  g1(8,7)=1;
  g1(8,24)=(-1);
  g1(9,3)=(-(params(4)*params(11)));
  g1(9,7)=1;
  g1(9,8)=(-((1-params(4))*params(11)));
  g1(9,23)=(-params(11));
  g1(10,5)=(-T336);
  g1(10,8)=(-params(16));
  g1(10,9)=1;
  g1(11,6)=(-params(31));
  g1(11,25)=(-(params(26)^2*params(7)*params(31)));
  g1(11,26)=1-(1-params(31));
  g1(12,11)=1;
  g1(12,13)=(-params(4));
  g1(12,21)=(-(1-params(4)));
  g1(12,23)=1;
  g1(13,12)=1;
  g1(13,13)=(-T21);
  g1(14,13)=1;
  g1(14,14)=1;
  g1(14,19)=(-1);
  g1(14,21)=(-1);
  g1(15,12)=(-1);
  g1(15,14)=1;
  g1(15,27)=(-1);
  g1(16,17)=(-params(31));
  g1(16,25)=(-(params(7)*params(26)^2*params(31)));
  g1(16,27)=1-(1-params(31));
  g1(17,15)=(-(T37*T43));
  g1(17,17)=1-(1+params(28)*params(26))*T37;
  g1(17,25)=(-1);
  g1(18,13)=(-(params(29)/(params(29)+1-params(8))));
  g1(18,15)=1-T60;
  g1(18,20)=(-1);
  g1(18,22)=1;
  g1(19,16)=T334;
  g1(19,20)=(-T80);
  g1(19,22)=T80;
  g1(20,12)=(-params(37));
  g1(20,16)=(-params(36));
  g1(20,17)=(-params(35));
  g1(20,18)=1;
  g1(20,24)=(-1);
  g1(21,14)=(-(params(4)*params(11)));
  g1(21,18)=1;
  g1(21,19)=(-((1-params(4))*params(11)));
  g1(21,23)=(-params(11));
  g1(22,11)=(-(T191*T205));
  g1(22,20)=1-T191*(params(28)*params(26)+params(14));
  g1(23,16)=(-(T238*T336));
  g1(23,19)=(-(params(16)*T238));
  g1(23,20)=(-(T211+params(12)/(1+params(28)*params(26))-(1+params(28)*params(26)*params(12))/(1+params(28)*params(26))));
  g1(23,21)=1-(T37+T211-T238);
  g1(24,7)=(-((-((1-params(21))*params(20)))-params(19)));
  g1(24,18)=(-((1-params(21))*params(20)+params(19)));
  g1(24,20)=(-(params(18)*(1-params(21))));
  g1(24,22)=1;
  g1(24,28)=(-params(21));
  g1(25,7)=(-(params(19)/params(21)));
  g1(25,18)=params(19)/params(21);
  g1(25,22)=(-1);
  g1(25,28)=1;
  g1(26,23)=1-params(22);
  g1(27,24)=1-params(23);
  g1(28,25)=1-params(24);
  g1(29,18)=(-1);
  g1(29,29)=1;
  g1(30,16)=(-1);
  g1(30,30)=1;
  g1(31,17)=(-1);
  g1(31,31)=1;
  g1(32,21)=(-1);
  g1(32,32)=1;
  g1(33,20)=(-1);
  g1(33,33)=1;
  g1(34,22)=(-1);
  g1(34,34)=1;
  g1(35,19)=(-1);
  g1(35,35)=1;
  if ~isreal(g1)
    g1 = real(g1)+2*imag(g1);
  end
end
if nargout >= 3,
%
% Hessian matrix
%

  g2 = sparse([],[],[],35,1225);
end;
