function [residual, g1, g2, g3] = sw4_dynamic(y, x, params, it_)
%
% Status : Computes dynamic model for Dynare
%
% Warning : this file is generated automatically by Dynare
%           from model file (.mod)

%
% Model equations
%

residual = zeros(35, 1);
T21 = 1/(params(5)/(1-params(5)));
T37 = 1/(1+params(28)*params(26));
T45 = 1/(params(26)^2*params(7));
T63 = (1-params(8))/(params(29)+1-params(8));
T70 = params(10)/params(26);
T84 = (params(9)-1)*params(38)/((1+T70)*params(9));
T90 = (1-T70)/((1+T70)*params(9));
T115 = 1/(1-T70);
T118 = T70/(1-T70);
T214 = 1/(1+params(28)*params(26)*params(14));
T229 = (1-params(15))*(1-params(28)*params(26)*params(15))/params(15)/(1+(params(11)-1)*params(2));
T236 = params(28)*params(26)/(1+params(28)*params(26));
T264 = (1-params(13))*(1-params(28)*params(26)*params(13))/((1+params(28)*params(26))*params(13))*1/(1+(params(17)-1)*params(1));
lhs =y(35);
rhs =params(4)*y(14)+(1-params(4))*y(21);
residual(1)= lhs-rhs;
lhs =y(13);
rhs =y(14)*T21;
residual(2)= lhs-rhs;
lhs =y(14);
rhs =y(21)+y(20)-y(15);
residual(3)= lhs-rhs;
lhs =y(15);
rhs =y(13)+y(10);
residual(4)= lhs-rhs;
lhs =y(18);
rhs =T37*(y(2)+params(28)*params(26)*y(51)+T45*y(16))+y(37);
residual(5)= lhs-rhs;
lhs =y(16);
rhs =(-y(22))+params(29)/(params(29)+1-params(8))*y(48)+T63*y(49);
residual(6)= lhs-rhs;
lhs =y(17);
rhs =T70/(1+T70)*y(1)+1/(1+T70)*y(50)+T84*(y(20)-y(52))-y(22)*T90;
residual(7)= lhs-rhs;
lhs =y(19);
rhs =y(17)*params(36)+y(18)*params(35)+y(36)+y(13)*params(37);
residual(8)= lhs-rhs;
lhs =y(19);
rhs =params(11)*(y(35)+params(4)*y(15)+(1-params(4))*y(20));
residual(9)= lhs-rhs;
lhs =y(21);
rhs =y(20)*params(16)+y(17)*T115-y(1)*T118;
residual(10)= lhs-rhs;
lhs =y(38);
rhs =y(10)*(1-params(31))+y(18)*params(31)+y(37)*params(26)^2*params(7)*params(31);
residual(11)= lhs-rhs;
lhs =y(23);
rhs =params(4)*y(25)+(1-params(4))*y(33)-y(35);
residual(12)= lhs-rhs;
lhs =y(24);
rhs =T21*y(25);
residual(13)= lhs-rhs;
lhs =y(25);
rhs =y(33)+y(31)-y(26);
residual(14)= lhs-rhs;
lhs =y(26);
rhs =y(24)+y(11);
residual(15)= lhs-rhs;
lhs =y(39);
rhs =(1-params(31))*y(11)+params(31)*y(29)+y(37)*params(7)*params(26)^2*params(31);
residual(16)= lhs-rhs;
lhs =y(29);
rhs =y(37)+T37*(y(4)+params(28)*params(26)*y(56)+T45*y(27));
residual(17)= lhs-rhs;
lhs =y(27);
rhs =(-y(34))+y(58)+params(29)/(params(29)+1-params(8))*y(53)+T63*y(54);
residual(18)= lhs-rhs;
lhs =y(28);
rhs =T70/(1+T70)*y(3)+1/(1+T70)*y(55)+T84*(y(31)-y(57))-T90*(y(34)-y(58));
residual(19)= lhs-rhs;
lhs =y(30);
rhs =y(36)+params(36)*y(28)+params(35)*y(29)+params(37)*y(24);
residual(20)= lhs-rhs;
lhs =y(30);
rhs =params(11)*(y(35)+params(4)*y(26)+(1-params(4))*y(31));
residual(21)= lhs-rhs;
lhs =y(32);
rhs =T214*(params(28)*params(26)*y(58)+params(14)*y(5)+y(23)*T229);
residual(22)= lhs-rhs;
lhs =y(33);
rhs =T37*y(6)+T236*y(59)+y(5)*params(12)/(1+params(28)*params(26))-y(32)*(1+params(28)*params(26)*params(12))/(1+params(28)*params(26))+y(58)*T236+T264*(params(16)*y(31)+T115*y(28)-T118*y(3)-y(33));
residual(23)= lhs-rhs;
lhs =y(34);
rhs =y(32)*params(18)*(1-params(21))+(1-params(21))*params(20)*(y(30)-y(19))+(y(30)-y(19))*params(19)+params(21)*y(12)+x(it_, 4);
residual(24)= lhs-rhs;
lhs =y(40);
rhs =y(34)-(y(30)-y(19))*params(19)/params(21);
residual(25)= lhs-rhs;
lhs =y(35);
rhs =params(22)*y(7)+x(it_, 1);
residual(26)= lhs-rhs;
lhs =y(36);
rhs =params(23)*y(8)+x(it_, 2)+x(it_, 1)*params(3);
residual(27)= lhs-rhs;
lhs =y(37);
rhs =params(24)*y(9)+x(it_, 3);
residual(28)= lhs-rhs;
lhs =y(41);
rhs =y(30)+log(params(40));
residual(29)= lhs-rhs;
lhs =y(42);
rhs =y(28)+log(params(41));
residual(30)= lhs-rhs;
lhs =y(43);
rhs =y(29)+log(params(42));
residual(31)= lhs-rhs;
lhs =y(44);
rhs =y(33)+log(params(43));
residual(32)= lhs-rhs;
lhs =y(45);
rhs =y(32)+log(params(44));
residual(33)= lhs-rhs;
lhs =y(46);
rhs =y(34)+log(params(45));
residual(34)= lhs-rhs;
lhs =y(47);
rhs =y(31)+log(params(46));
residual(35)= lhs-rhs;
if nargout >= 2,
  g1 = zeros(35, 63);

%
% Jacobian matrix
%

g1(1,14)=(-params(4));
g1(1,21)=(-(1-params(4)));
g1(1,35)=1;
g1(2,13)=1;
g1(2,14)=(-T21);
g1(3,14)=1;
g1(3,15)=1;
g1(3,20)=(-1);
g1(3,21)=(-1);
g1(4,13)=(-1);
g1(4,15)=1;
g1(4,10)=(-1);
g1(5,16)=(-(T37*T45));
g1(5,2)=(-T37);
g1(5,18)=1;
g1(5,51)=(-(params(28)*params(26)*T37));
g1(5,37)=(-1);
g1(6,48)=(-(params(29)/(params(29)+1-params(8))));
g1(6,16)=1;
g1(6,49)=(-T63);
g1(6,22)=1;
g1(7,1)=(-(T70/(1+T70)));
g1(7,17)=1;
g1(7,50)=(-(1/(1+T70)));
g1(7,20)=(-T84);
g1(7,52)=T84;
g1(7,22)=T90;
g1(8,13)=(-params(37));
g1(8,17)=(-params(36));
g1(8,18)=(-params(35));
g1(8,19)=1;
g1(8,36)=(-1);
g1(9,15)=(-(params(4)*params(11)));
g1(9,19)=1;
g1(9,20)=(-((1-params(4))*params(11)));
g1(9,35)=(-params(11));
g1(10,1)=T118;
g1(10,17)=(-T115);
g1(10,20)=(-params(16));
g1(10,21)=1;
g1(11,18)=(-params(31));
g1(11,37)=(-(params(26)^2*params(7)*params(31)));
g1(11,10)=(-(1-params(31)));
g1(11,38)=1;
g1(12,23)=1;
g1(12,25)=(-params(4));
g1(12,33)=(-(1-params(4)));
g1(12,35)=1;
g1(13,24)=1;
g1(13,25)=(-T21);
g1(14,25)=1;
g1(14,26)=1;
g1(14,31)=(-1);
g1(14,33)=(-1);
g1(15,24)=(-1);
g1(15,26)=1;
g1(15,11)=(-1);
g1(16,29)=(-params(31));
g1(16,37)=(-(params(7)*params(26)^2*params(31)));
g1(16,11)=(-(1-params(31)));
g1(16,39)=1;
g1(17,27)=(-(T37*T45));
g1(17,4)=(-T37);
g1(17,29)=1;
g1(17,56)=(-(params(28)*params(26)*T37));
g1(17,37)=(-1);
g1(18,53)=(-(params(29)/(params(29)+1-params(8))));
g1(18,27)=1;
g1(18,54)=(-T63);
g1(18,58)=(-1);
g1(18,34)=1;
g1(19,3)=(-(T70/(1+T70)));
g1(19,28)=1;
g1(19,55)=(-(1/(1+T70)));
g1(19,31)=(-T84);
g1(19,57)=T84;
g1(19,58)=(-T90);
g1(19,34)=T90;
g1(20,24)=(-params(37));
g1(20,28)=(-params(36));
g1(20,29)=(-params(35));
g1(20,30)=1;
g1(20,36)=(-1);
g1(21,26)=(-(params(4)*params(11)));
g1(21,30)=1;
g1(21,31)=(-((1-params(4))*params(11)));
g1(21,35)=(-params(11));
g1(22,23)=(-(T214*T229));
g1(22,5)=(-(params(14)*T214));
g1(22,32)=1;
g1(22,58)=(-(params(28)*params(26)*T214));
g1(23,3)=(-(T264*(-T118)));
g1(23,28)=(-(T115*T264));
g1(23,31)=(-(params(16)*T264));
g1(23,5)=(-(params(12)/(1+params(28)*params(26))));
g1(23,32)=(1+params(28)*params(26)*params(12))/(1+params(28)*params(26));
g1(23,58)=(-T236);
g1(23,6)=(-T37);
g1(23,33)=1-(-T264);
g1(23,59)=(-T236);
g1(24,19)=(-((-((1-params(21))*params(20)))-params(19)));
g1(24,30)=(-((1-params(21))*params(20)+params(19)));
g1(24,32)=(-(params(18)*(1-params(21))));
g1(24,34)=1;
g1(24,12)=(-params(21));
g1(24,63)=(-1);
g1(25,19)=(-(params(19)/params(21)));
g1(25,30)=params(19)/params(21);
g1(25,34)=(-1);
g1(25,40)=1;
g1(26,7)=(-params(22));
g1(26,35)=1;
g1(26,60)=(-1);
g1(27,8)=(-params(23));
g1(27,36)=1;
g1(27,60)=(-params(3));
g1(27,61)=(-1);
g1(28,9)=(-params(24));
g1(28,37)=1;
g1(28,62)=(-1);
g1(29,30)=(-1);
g1(29,41)=1;
g1(30,28)=(-1);
g1(30,42)=1;
g1(31,29)=(-1);
g1(31,43)=1;
g1(32,33)=(-1);
g1(32,44)=1;
g1(33,32)=(-1);
g1(33,45)=1;
g1(34,34)=(-1);
g1(34,46)=1;
g1(35,31)=(-1);
g1(35,47)=1;
end
if nargout >= 3,
%
% Hessian matrix
%

  g2 = sparse([],[],[],35,3969);
end;
if nargout >= 4,
%
% Third order derivatives
%

  g3 = sparse([],[],[],35,250047);
end;
